MapType
Date: 2016-12-04

com.fasterxml.jackson.databind.type

## Class MapType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.MapLikeType
        - - com.fasterxml.jackson.databind.type.MapType

- All Implemented Interfaces:
    JsonSerializable, java.io.Serializable, java.lang.reflect.Type

      public final class MapType
      extends MapLikeType

  Type that represents "true" Java Map types.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

      `JsonSerializable.Base`

  - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.type.MapLikeType

      `_keyType, _valueType`

    - ### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bindings, _superClass, _superInterfaces`

    - ### Fields inherited from class com.fasterxml.jackson.databind.JavaType

      `_asStatic, _class, _hash, _typeHandler, _valueHandler`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `MapType(TypeBase base, JavaType keyT, JavaType valueT)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JavaType` | `_narrow(java.lang.Class<?> subclass)` Deprecated.
    `static MapType` | `construct(java.lang.Class<?> rawType, JavaType keyT, JavaType valueT)` Deprecated.
    `static MapType` | `construct(java.lang.Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType keyT, JavaType valueT)`
    `JavaType` | `refine(java.lang.Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
    `java.lang.String` | `toString()`
    `JavaType` | `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
    `MapType` | `withContentTypeHandler(java.lang.Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
    `MapType` | `withContentValueHandler(java.lang.Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
    `MapType` | `withKeyType(JavaType keyType)`
    `MapType` | `withKeyTypeHandler(java.lang.Object h)`
    `MapType` | `withKeyValueHandler(java.lang.Object h)`
    `MapType` | `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
    `MapType` | `withTypeHandler(java.lang.Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
    `MapType` | `withValueHandler(java.lang.Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

    - ### Methods inherited from class com.fasterxml.jackson.databind.type.MapLikeType

      `buildCanonicalName, equals, getContentType, getContentTypeHandler, getContentValueHandler, getErasedSignature, getGenericSignature, getKeyType, hasHandlers, isContainerType, isMapLikeType, isTrueMapType, upgradeFrom, withHandlersFrom`

    - ### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bogusSuperClass, _classSignature, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, serialize, serializeWithType, toCanonical`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JavaType

      `containedTypeOrUnknown, forcedNarrowBy, getErasedSignature, getGenericSignature, getParameterSource, getRawClass, getReferencedType, getTypeHandler, getValueHandler, hasContentType, hasGenericTypes, hashCode, hasRawClass, hasValueHandler, isAbstract, isArrayType, isCollectionLikeType, isConcrete, isEnumType, isFinal, isInterface, isJavaLangObject, isPrimitive, isThrowable, isTypeOrSubTypeOf, useStaticType`

    - ### Methods inherited from class com.fasterxml.jackson.core.type.ResolvedType

      `isReferenceType`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MapType

          protected MapType(TypeBase base,
                 JavaType keyT,
                 JavaType valueT)

      Since:
        2.7

  - ### Method Detail

    - #### construct

          public static MapType construct(java.lang.Class<?> rawType,
                          TypeBindings bindings,
                          JavaType superClass,
                          JavaType[] superInts,
                          JavaType keyT,
                          JavaType valueT)

      Since:
        2.7

    - #### construct

          @Deprecated
          public static MapType construct(java.lang.Class<?> rawType,
                                     JavaType keyT,
                                     JavaType valueT)

      Deprecated.

    - #### _narrow

          @Deprecated
          protected JavaType _narrow(java.lang.Class<?> subclass)

      Deprecated.
      Overrides:
        `_narrow` in class `MapLikeType`

    - #### withTypeHandler

          public MapType withTypeHandler(java.lang.Object h)

      Description copied from class: `JavaType`
      "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
      Overrides:
        `withTypeHandler` in class `MapLikeType`
      Returns:
        Newly created type instance

    - #### withContentTypeHandler

          public MapType withContentTypeHandler(java.lang.Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
      Overrides:
        `withContentTypeHandler` in class `MapLikeType`
      Returns:
        Newly created type instance, with given

    - #### withValueHandler

          public MapType withValueHandler(java.lang.Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.
      Overrides:
        `withValueHandler` in class `MapLikeType`
      Returns:
        Newly created type instance

    - #### withContentValueHandler

          public MapType withContentValueHandler(java.lang.Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
      Overrides:
        `withContentValueHandler` in class `MapLikeType`
      Returns:
        Newly created type instance

    - #### withStaticTyping

          public MapType withStaticTyping()

      Description copied from class: `JavaType`
      Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).
      Overrides:
        `withStaticTyping` in class `MapLikeType`

    - #### withContentType

          public JavaType withContentType(JavaType contentType)

      Description copied from class: `JavaType`
      Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.
      Overrides:
        `withContentType` in class `MapLikeType`
      Returns:
        Newly created type instance

    - #### withKeyType

          public MapType withKeyType(JavaType keyType)

      Overrides:
        `withKeyType` in class `MapLikeType`

    - #### refine

          public JavaType refine(java.lang.Class<?> rawType,
                        TypeBindings bindings,
                        JavaType superClass,
                        JavaType[] superInterfaces)

      Description copied from class: `JavaType`
      Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
      Overrides:
        `refine` in class `MapLikeType`

    - #### withKeyTypeHandler

          public MapType withKeyTypeHandler(java.lang.Object h)

      Overrides:
        `withKeyTypeHandler` in class `MapLikeType`

    - #### withKeyValueHandler

          public MapType withKeyValueHandler(java.lang.Object h)

      Overrides:
        `withKeyValueHandler` in class `MapLikeType`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `MapLikeType`